import pygame
from network import Network
import pickle
from multi import spiel
pygame.font.init()

width = 1000
height = 700
win = pygame.display.set_mode((width, height))
pygame.display.set_caption("Schiffe versenken")

class Button:
    def __init__(self, text, x, y, color):
        self.text = text
        self.x = x
        self.y = y
        self.color = color
        self.width = 150
        self.height = 100

    def draw(self, win):
        pygame.draw.rect(win, self.color, (self.x, self.y, self.width, self.height))
        font = pygame.font.SysFont("comicsans", 40)
        text = font.render(self.text, 1, (255,255,255))
        win.blit(text, (self.x + round(self.width/2) - round(text.get_width()/2), self.y + round(self.height/2) - round(text.get_height()/2)))

    def click(self, pos):#klick in button?
        x1 = pos[0]
        y1 = pos[1]
        if self.x <= x1 <= self.x + self.width and self.y <= y1 <= self.y + self.height:
            return True
        else:
            return False


def redrawWindow(win, game, p, spiele):
    #pygame.draw.rect(win,(128,128,128),[0,450,width-100,height-400-100])#feld mit grau uebermalen (nicht die spielfelder)
    #change=False
    if not(game.connected()):#nicht 2 spieler in game[]
        font = pygame.font.SysFont("comicsans", 80)
        text = font.render("Waiting for Player...", 1, (255,0,0), True )
        win.blit(text, (width/2 - text.get_width()/2, (height+spiele[0].window_size[1])/2 - text.get_height()/2))
        
    else:
        font = pygame.font.SysFont("comicsans", 60)
        """
        text = font.render("Your Move", 1, (0, 255,255))#buttons anzeigen
        win.blit(text, (80, 200))

        text = font.render("Opponents", 1, (0, 255, 255))
        win.blit(text, (380, 200))

        move1 = game.get_player_move(0)#aktuellen zug ausgeben
        move2 = game.get_player_move(1)
        if game.bothWent():#beide haben einen zug gemacht
            if 
            text1 = font.render(move1, 1, (0,0,0))#aenderungen printen
            text2 = font.render(move2, 1, (0, 0, 0))
            change=True"""
        if not game.bothWent():
            
            if game.p1Went:#der andere spieler hat einen zug gemacht
                text1 = font.render("Locked In", 1, (0, 0, 0))
                #change=True
            else:#niemand hat einen zug gemacht
                text1 = font.render("Waiting...", 1, (0, 0, 0))

            if game.p2Went:#der andere spieler hat einen zug gemacht
                text2 = font.render("Locked In", 1, (0, 0, 0))
                #change=True
            else:#niemand hat einen zug gemacht
                text2 = font.render("Waiting...", 1, (0, 0, 0))

        """if change:
            spiele[0].printf()
            spiele[1].printf()"""
        

        
        if p == 1:#spieler 2 selbst links und spieler 1 rechts
            win.blit(text2, (100, 500))
            win.blit(text1, (600, 500))
        else:#spieler 1 selbst links und spieler 2 rechts
            win.blit(text1, (100, 500))
            win.blit(text2, (600, 500))

        #for btn in btns:#buttons printen
         #   btn.draw(win)

    pygame.display.update()#pixel aktualisieren


#btns = [Button("Menu", 50, 500, (0,0,0)), Button("back", 250, 500, (255,0,0)), Button("confirm", 450, 500, (0,255,0))]
#buttons initiieren
def main():
    run = True
    win.fill((128,128,128))
    spiele=[spiel(win,[50,0]),spiel(win,[550,0])]
    spiele[0].reset()
    spiele[1].reset()
   
    clock = pygame.time.Clock()
    n = Network()
  
    try:
        player = int(n.getP())#spieler 1 oder 2? vom server
    except:#sonst kein server da
        print("server offline")
        return "off"
    print("You are player", player)
    while run:
        clock.tick(30)#60 fps
        try:
            game=n.send("update")#server aktuelles aussehen ubermitteln
            
            
        except:
            run = False
            print("Couldn't get game")
            break
        
        if spiele[0].step!=3:#beim eingeben nur die eigene aktivitaet laden
            spiele[0].printf()#linke seite printen

        else:#versenken:treffer,daneben, versenkt anzeigen
            spiele[0].printgrid()
            if player ==0:#rechte seite printen
                    x=game.moves[1]
                    if x and x!=0:
                        spiele[1].grid=x
                    
            else:
                    x=game.moves[0]
                    if x and x!=0:
                        spiele[1].grid=x
            spiele[1].printgrid()
            
        if not game.moves[player] or game.moves[player]==0 and game.connected():#wenn noch kein zug gemacht wurde
            if spiele[0].step==1:
                y=spiele[0].input()
            
            elif spiele[0].step==3:
                y=spiele[0].zug()
                
        
                if x:#wenn die vorherige funktion zu einem ergebnis gefuehrt hat
                    if x=="exit":#wenn beendet wurde dann zum startbildschirm
                        break
                    n.send(x)#ergebnis an server schicken
        
        if game.bothWent():#zug von beiden beendet
            if spiele[0].step==2:#wenn input fertig
                y=n.send("swap")
                spiele[0].reset()
                spiele[1].reset()
                spiele[0].step=3#wenn swap fertig
            redrawWindow(win, game, player, spiele)
            pygame.time.delay(500)
            try:
                n.send("reset")#neuen zug vom server anfordern
            except:
                run = False
                print("Couldn't get game")
                break
            """ erst wenn ein ergebnis =="win"//or"exit"""
            font = pygame.font.SysFont("comicsans", 90)
            if (game.winner() == 1 and player == 1) or (game.winner() == 0 and player == 0):
                text = font.render("You Won!", 1, (255,0,0))
            elif game.winner() == -1:
                text = font.render("Tie Game!", 1, (255,0,0))
            else:
                text = font.render("You Lost...", 1, (255, 0, 0))

            
            win.blit(text, (width/2 - text.get_width()/2, height/2 - text.get_height()/2))
            
            pygame.display.update()
            pygame.time.delay(2000)#text 2 sekunden anzeigen
            
            

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                run = False
                pygame.quit()

            if event.type== pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    run=False
                    return True#sollte eig zum startbildschirm fuehren
            """
            if event.type == pygame.MOUSEBUTTONDOWN:#falls buttons benutzt werden
                pos = pygame.mouse.get_pos()#klick auf button?
                for btn in btns:
                    if btn.click(pos) and game.connected():
                        if player == 0:
                            if not game.p1Went:#wenn spieler noch nicht einen zug gemacht hat
                                n.send(btn.text)#zug an server senden
                        else:
                            if not game.p2Went:
                                n.send(btn.text)"""
        #try:
        redrawWindow(win, game, player, spiele)#infos einzeichnen
            
        """    
        except:#wenn das nicht geht hat mind. ein spieler beendet
            print("player disconnected", player)
            pygame.quit()
            break"""
        

def menu_screen():#startbildschirm
    run = True
    clock = pygame.time.Clock()

    while run:
        clock.tick(30)
        try:
            win.fill((128, 128, 128))#grauer hintergrund
        except:
            return False#Falls Fenster unerwartet geschlossen wurde
        font = pygame.font.SysFont("comicsans", 60)
        text = font.render("Click to Play!", 1, (255,0,0))
        win.blit(text, (width/2 - text.get_width()/2, height/2 - text.get_height()/2))
        pygame.display.update()#cklick to play zeichnen

        for event in pygame.event.get():#warten auf klick/exit
            if event.type == pygame.QUIT:
                pygame.quit()
                run = False
            if event.type == pygame.MOUSEBUTTONDOWN:
                run = False
    
    x=main()#spiel starten
    if x=="off":#keine antwort vom server:
        run=True
        win.fill((128, 128, 128))
        font = pygame.font.SysFont("comicsans", 60)
        text = font.render("Server offline", 1, (255,0,0))
        win.blit(text, (100,200))
        pygame.display.update()
        while run:
            for event in pygame.event.get():#warten auf klick/exit
                if event.type == pygame.QUIT:
                    pygame.quit()
                    run = False
                if event.type == pygame.MOUSEBUTTONDOWN:
                    run = False
    return True
        #danach nochmal verbindung versuchen (wieder von vorne ausgefuehrt)
while True:
    if not menu_screen():#solange eigenes fenster existiert
        break#programm beenden
